︠d0e32742-b4b9-4a8e-8d03-6e21dc13df68s︠
# Kaip papildyti vektorių sistemą iki erdvės bazės?

def papildom_poerdviai(W, V):
    """
    Gražina tiesinės erdvės V poerdvio W papildinio iki V bazę. 
    Kitaip sakant, randa tokį poerdvį U, kad V yra W ir U tiesioginė 
    suma ir gražina jo bazę.
    """
    Q, pi, lift = V.quotient_abstract(W)
    Basis = [lift(v) for v in Q.basis()]
    return Basis

# pi   yra projekcijos atvaizdis iš erdvės V į faktorerdvę V/W: pi(v) = v + W.
# lift yra "atvirkštinis" atvaizdis iš faktorerdvės Q = V/W  į  erdvę V, tenkinantis 
# lygybę pi(lift(u)) = u  su visais u iš Q.


def papildom(vec, V):
    """
    Tiesinės erdvės V vektorių šeimą vec papildo vektoriais v1,..., vn iki 
    erdvės V bazės ir gražina papildytus vektorius v1,..., vn.
    """
    return papildom_poerdviai(V.span(vec), V)

︡0d27bf3f-556a-4709-be40-4a1a6ba2153a︡{"done":true}
︠30496725-32dd-4d1a-853d-48b31d3bd9cas︠
A_eilutes = [[244,-103,-92,24,71,-24,37,-16],
    [697,-297,-265,67,203,-68,112,-48],
    [781,-336,-294,77,227,-76,124,-54],
    [341,-148,-129,37,97,-32,56,-25],
    [781,-336,-297,76,230,-76,125,-54],
    [-21,13,6,3,-3,3,-12,4],
    [341,-148,-129,34,97,-32,59,-25],
    [-571,246,217,-52,-167,56,-94,42]]
A = matrix(QQ,8,8,A_eilutes)
︡67ca239f-02a6-4d14-9bfb-f8f14b205174︡{"done":true}
︠4df37f34-40fa-4386-8d3e-acf546497e8fs︠
# 5 pavyzdys. Rasime matricos
show(A)
︡81f1f639-9a31-4453-bde3-8eb0f16aa3a6︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrrrrrrr}\n244 &amp; -103 &amp; -92 &amp; 24 &amp; 71 &amp; -24 &amp; 37 &amp; -16 \\\\\n697 &amp; -297 &amp; -265 &amp; 67 &amp; 203 &amp; -68 &amp; 112 &amp; -48 \\\\\n781 &amp; -336 &amp; -294 &amp; 77 &amp; 227 &amp; -76 &amp; 124 &amp; -54 \\\\\n341 &amp; -148 &amp; -129 &amp; 37 &amp; 97 &amp; -32 &amp; 56 &amp; -25 \\\\\n781 &amp; -336 &amp; -297 &amp; 76 &amp; 230 &amp; -76 &amp; 125 &amp; -54 \\\\\n-21 &amp; 13 &amp; 6 &amp; 3 &amp; -3 &amp; 3 &amp; -12 &amp; 4 \\\\\n341 &amp; -148 &amp; -129 &amp; 34 &amp; 97 &amp; -32 &amp; 59 &amp; -25 \\\\\n-571 &amp; 246 &amp; 217 &amp; -52 &amp; -167 &amp; 56 &amp; -94 &amp; 42\n\\end{array}\\right)$</div>"}︡{"done":true}
︠fb199b02-96ef-43e4-a2cc-9ae3167ce57d︠
# Žodano formą ir atitinkamą bazę.
︡63ca029e-ba8a-43d7-8e02-4fab12cc094f︡
︠8555027e-5823-4784-8596-081a5d57f26bi︠
%md 
Sprendimas
︡c17382eb-1570-49fa-a1f7-ae32bc254e73︡{"md":"Sprendimas\n"}︡
︠8a97b92a-a29e-4f6b-bc6a-e43341fe7f31s︠
# Randame matricos charakteristinį polinomą:

p = A.charpoly(var = 't')
show(p.factor())
︡48d33af9-43d2-4639-bdb0-56b65de68976︡{"html":"<div align='center'>$\\displaystyle (t - 3)^{8}$</div>"}︡{"done":true}
︠55f5051b-c9a1-4efa-b320-0a4286c07211s︠
# Nagrinėjame matricą B := A-3*E ir skaičiuojame jos laipsnių branduolių dimensijas:
B = A - 3*matrix.identity(8)
show(B)
︡b0e913ff-1355-47bb-8390-8ab49a107591︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrrrrrrr}\n241 &amp; -103 &amp; -92 &amp; 24 &amp; 71 &amp; -24 &amp; 37 &amp; -16 \\\\\n697 &amp; -300 &amp; -265 &amp; 67 &amp; 203 &amp; -68 &amp; 112 &amp; -48 \\\\\n781 &amp; -336 &amp; -297 &amp; 77 &amp; 227 &amp; -76 &amp; 124 &amp; -54 \\\\\n341 &amp; -148 &amp; -129 &amp; 34 &amp; 97 &amp; -32 &amp; 56 &amp; -25 \\\\\n781 &amp; -336 &amp; -297 &amp; 76 &amp; 227 &amp; -76 &amp; 125 &amp; -54 \\\\\n-21 &amp; 13 &amp; 6 &amp; 3 &amp; -3 &amp; 0 &amp; -12 &amp; 4 \\\\\n341 &amp; -148 &amp; -129 &amp; 34 &amp; 97 &amp; -32 &amp; 56 &amp; -25 \\\\\n-571 &amp; 246 &amp; 217 &amp; -52 &amp; -167 &amp; 56 &amp; -94 &amp; 39\n\\end{array}\\right)$</div>"}︡{"done":true}
︠f839f5d1-0e63-45b5-a8e8-c687626af9d3s︠
# Matricos B branduolys ker B ir jo dimensija:
L1 = B.left_kernel()
L1.dimension()
︡fa39c251-83fb-431a-9a8e-1f3d08f505a6︡{"stdout":"4\n"}︡{"done":true}
︠561a0d81-5b90-4a8e-a9d8-548373343eads︠
# Matricos B^2 branduolys ker B^2 ir jo dimensija:
L2 = (B**2).left_kernel()
L2.dimension()
︡4957e15b-ed88-4c49-81ab-e25446a4e99d︡{"stdout":"7\n"}︡{"done":true}
︠0fec9938-6d08-4b4a-9edd-5497c9466783s︠
# Matricos B^3 branduolys ker B^3 ir jo dimensija:
L3 = (B**3).left_kernel()
L3.dimension()
︡08b8e274-57d7-433a-8088-a914628940fc︡{"stdout":"8\n"}︡{"done":true}
︠e003613d-1849-4d3c-bd59-3935719e3888s︠
# Poerdvio L2 bazę pildant iki erdvės L3 bazės, reikia pridėti 1 vektorių, kurį 
# atitiks lygiai vianas 3-os eilės Žordano langelis.
# Rasime šį vektorių:

v1 = papildom(L2.basis(), L3)[0]
v1
︡283c4588-55d0-496b-92d8-07d56bd63e34︡{"stdout":"(1, 0, 0, 0, 0, 0, 0, 0)\n"}︡{"done":true}
︠37f72aa0-d152-4557-b9a3-8bccf955e21cs︠
# Suskaičiuojame dar du vektorius:

v2 = v1*B  # priklauso L2
v3 = v2*B  # priklauso L1
v2
v3
︡2b3b4f78-f6ea-4660-a610-34a24d7a5143︡{"stdout":"(241, -103, -92, 24, 71, -24, 37, -16)\n"}︡{"stdout":"(330, -143, -125, 29, 96, -32, 56, -23)\n"}︡{"done":true}
︠76fd8c47-ef88-4806-b386-f1a4a0411617s︠
# Vektorius v1, v2 ir v3 atitinka lygiai vianas 3-os eilės Žordano langelis. 

# Poerdvio L1 bazę pildant iki erdvės L2 bazės, reikia pridėti 3 vektorius.
# Vieną vektorių jau turime: vektorius v2 priklauso L2, bet nepriklauso L1.
# Taigi vektorių šeimą {v2, L1 bazė} pildant iki L2 bazės, reikės pridėti 
# lygiai 2 vektorius. Kiekvieną iš šių vektorių atitiks 2-os eilės Žordano 
# langelis. Rasime šiuos vektorius:

vektoriai = papildom(L1.basis()+[v2], L2)
v4 = vektoriai[0]
v6 = vektoriai[1]
v4
v6
︡332225de-1700-429a-baf8-a6754cfbcf31︡{"stdout":"(1, 0, 0, 0, 0, 0, 0, 1)\n"}︡{"stdout":"(0, 1, 0, 0, 0, 0, 0, 1)\n"}︡{"done":true}
︠74bdb1a7-d3aa-4ec7-be3a-77a6dc7b6c31s︠
# Suskaičiuojame dar du vektorius:

v5 = v4*B  # priklauso L1
v7 = v6*B  # priklauso L1
v5
v7
︡151c4134-0e70-4db7-9660-eedb4e01322e︡{"stdout":"(-330, 143, 125, -28, -96, 32, -57, 23)\n"}︡{"stdout":"(126, -54, -48, 15, 36, -12, 18, -9)\n"}︡{"done":true}
︠87cc1a4b-5fb3-4a30-a49d-d659995df9a4s︠
# Vektorius v4, v5 atitinka vienas 2-os eilės Žordano langelis, o 
# vektorius v6, v7 -- dar vienas 2-os eilės Žordano langelis.

# Poerdvyje L1 turime 3 tiesiškai nepriklausomus vektorius v3,v5 ir v7.
# Šią vektorių šeimą pildant iki erdvės L1 bazės, reikės pridėti vieną 
# vektorių. Rasime šį vektorių:

v8 = papildom([v3,v5,v7], L1)[0]
v8
︡fdb19339-ff22-4f9c-b681-e41a3ee4758f︡{"stdout":"(1, 0, 0, 0, -9/2, 3/2, 17/4, -13/4)\n"}︡{"done":true}
︠ee05924e-c11d-48e6-a106-c0569d3049a0s︠

# Taigi radome Žordano bazę v1,v2,...,v8. 
# Perėjimo matrica (iš standartinės bazės į Žordano bazę):

T = matrix(QQ,8,8,[v1,v2,v3,v4,v5,v6,v7,v8])
show(T)
︡6f84c80e-8b45-4698-84a9-56f960905424︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrrrrrrr}\n1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 \\\\\n241 &amp; -103 &amp; -92 &amp; 24 &amp; 71 &amp; -24 &amp; 37 &amp; -16 \\\\\n330 &amp; -143 &amp; -125 &amp; 29 &amp; 96 &amp; -32 &amp; 56 &amp; -23 \\\\\n1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 1 \\\\\n-330 &amp; 143 &amp; 125 &amp; -28 &amp; -96 &amp; 32 &amp; -57 &amp; 23 \\\\\n0 &amp; 1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 1 \\\\\n126 &amp; -54 &amp; -48 &amp; 15 &amp; 36 &amp; -12 &amp; 18 &amp; -9 \\\\\n1 &amp; 0 &amp; 0 &amp; 0 &amp; -\\frac{9}{2} &amp; \\frac{3}{2} &amp; \\frac{17}{4} &amp; -\\frac{13}{4}\n\\end{array}\\right)$</div>"}︡{"done":true}
︠71220edc-2b06-4d68-b5b2-9ff06067ba9as︠
# Pradinės matricos Žordano matrica:

show(T*A*(T^(-1)))
︡6ae70a94-d082-463e-9f25-d1cd470bb12f︡{"html":"<div align='center'>$\\displaystyle \\left(\\begin{array}{rrrrrrrr}\n3 &amp; 1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 \\\\\n0 &amp; 3 &amp; 1 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 \\\\\n0 &amp; 0 &amp; 3 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 \\\\\n0 &amp; 0 &amp; 0 &amp; 3 &amp; 1 &amp; 0 &amp; 0 &amp; 0 \\\\\n0 &amp; 0 &amp; 0 &amp; 0 &amp; 3 &amp; 0 &amp; 0 &amp; 0 \\\\\n0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 3 &amp; 1 &amp; 0 \\\\\n0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 3 &amp; 0 \\\\\n0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 0 &amp; 3\n\\end{array}\\right)$</div>"}︡{"done":true}
︠f7694100-1a48-4cf5-94f8-46e0080c88a4︠









